"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useListener = void 0;
var react_1 = require("react");
var useController_1 = require("./useController");
function useListener(context, listener, listenWhen) {
    var controller = (0, useController_1.useController)(context);
    var stateRef = (0, react_1.useRef)(controller.state);
    var emitState = function (newState) {
        listener(newState);
    };
    (0, react_1.useEffect)(function () {
        var subcription = controller.observable.subscribe(function (newState) {
            var state = stateRef.current;
            if (listenWhen) {
                if (listenWhen === null || listenWhen === void 0 ? void 0 : listenWhen(state, newState)) {
                    emitState(newState);
                }
            }
            else {
                emitState(newState);
            }
            stateRef.current = newState;
        });
        return function () {
            subcription.unsubscribe();
        };
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [listenWhen, listener]);
    return controller;
}
exports.useListener = useListener;
//# sourceMappingURL=useListener.js.map