import { __awaiter, __generator } from "tslib";
import { BehaviorSubject } from 'rxjs';
var Controller = /** @class */ (function () {
    function Controller(initialState) {
        this._subject = new BehaviorSubject(initialState);
    }
    Object.defineProperty(Controller.prototype, "observable", {
        get: function () {
            return this._subject.asObservable();
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Controller.prototype, "state", {
        get: function () {
            return this._subject.value;
        },
        enumerable: false,
        configurable: true
    });
    Controller.prototype.emit = function (state) {
        if (this.state === state) {
            return;
        }
        this._subject.next(state);
    };
    Controller.prototype.dispose = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this._subject.complete();
                return [2 /*return*/];
            });
        });
    };
    return Controller;
}());
export default Controller;
//# sourceMappingURL=Controller.js.map