import { jsx as _jsx, Fragment as _Fragment } from "react/jsx-runtime";
import { createContext, useEffect, useRef } from 'react';
import { useBuilder } from './useBuilder';
import { useListener } from './useListener';
import { useController } from './useController';
function createControllerContext() {
    var reactContext = createContext(undefined);
    var controllerContext = {
        Provider: null,
        Builder: null,
        Listener: null,
        _context: reactContext,
    };
    var ControllerProvider = function (_a) {
        var create = _a.create, children = _a.children;
        var controllerRef = useRef(create());
        useEffect(function () { return function () {
            controllerRef.current.dispose();
        }; }, []);
        return _jsx(reactContext.Provider, { value: controllerRef.current, children: children });
    };
    controllerContext.Provider = ControllerProvider;
    var Builder = function (_a) {
        var builder = _a.builder, buildWhen = _a.buildWhen;
        var _b = useBuilder(controllerContext, buildWhen), state = _b[0], controller = _b[1];
        var renderComponent = function () {
            return builder(state, controller);
        };
        return renderComponent();
    };
    controllerContext.Builder = Builder;
    var Listener = function (_a) {
        var listener = _a.listener, listenWhen = _a.listenWhen, children = _a.children;
        var controller = useController(controllerContext);
        useListener(controllerContext, function (state) { return listener(state, controller); }, listenWhen);
        return _jsx(_Fragment, { children: children });
    };
    controllerContext.Listener = Listener;
    return controllerContext;
}
export { createControllerContext };
//# sourceMappingURL=ControllerContext.js.map